# No need for debuginfo or stripping
%global debug_package %{nil}
%global __strip /bin/true

Name:           freedom-u540-c000-bootloader
Version:        2019.08.25.128f282
Release:        1%{?dist}
Summary:        SiFive FU540 ZSBL and FSBL

License:        Apache-2.0 | GPLv2+
URL:            https://github.com/sifive/freedom-u540-c000-bootloader
# This is a full git clone copy (incl. git), --depth 1 should be enough
# This allows Makefile to extract version information from .git
Source0:        %{name}-%{version}.tar.xz

Patch0:         drop-unneeded-sectiosn-fix-string.patch

# We depend on kernel for a new DTB
BuildRequires:  kernel-core
# Needed to generate version information
BuildRequires:  git
# Needed to compile DTB ( ZSBL and FSBL)
BuildRequires:  dtc

BuildRequires:  gcc
BuildRequires:  binutils

%description
Provides booloaders for SiFive (FU540) HiFive Unleashed board:
- Zeroth Stage Boot Loader (ZSBL)
- First Stage Boot Loader (FSBL)

%prep
%autosetup -p1

%build
make CROSSCOMPILE=

%install
install -d %{buildroot}/boot/freedom-u540-c000-bootloader/unstable/
install -m 755 zsbl.bin %{buildroot}/boot/freedom-u540-c000-bootloader/unstable/
install -m 755 fsbl.bin %{buildroot}/boot/freedom-u540-c000-bootloader/unstable/

%files
%license LICENSE
/boot/freedom-u540-c000-bootloader/unstable/{zsbl,fsbl}.bin

%changelog
* Sun Aug 25 2019 David Abdurachmanov <david.abdurachmanov@sifive.com> 2019.08.25.128f282-1
- Add initial version


